<template>
  <div>
    <v-file-input dense accent="image/*" chips show-size @change="imageSelect = $event"></v-file-input>
    <v-btn class="text-capitalize" color="primary" @click.stop="uploadFile">Send</v-btn>
    <v-btn class="text-capitalize" color="red" @click="downloadtest" target="blank">Download</v-btn>

    <v-btn color="orange lighten-2" @click="test">Test</v-btn>
  </div>
</template>
<script>
const AWS = require("aws-sdk");
const path = require("path");
const bucket_name = "snapbox2";
const ACCESS_KEY_ID = "AKIARH35CKNB46WQM57E";
const SECRET_KEY = "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";
AWS.config.update({
  accessKeyId: ACCESS_KEY_ID,
  secretAccessKey: SECRET_KEY
});
let s3 = new AWS.S3();
// Configure the file stream and obtain the upload parameters
export default {
  data: () => ({
    imageSelect: null
  }),
  methods: {
    uploadFile: function() {
      if (this.imageSelect) {
        const params = {
          Bucket: bucket_name,
          Key: this.imageSelect.name,
          Body: this.imageSelect
        };
        s3.upload(params, function(err, data) {
          if (err) {
            console.log(err);
          } else {
            console.log(data);
          }
        });
      } else {
        console.log("file ko ton tai");
      }
    },
    downloadtest: function() {
      const paramsDown = {
        Bucket: bucket_name,
        Key:
          "tested/Beautiful-Blue-Girl-butterfly-hand-magic-weapon-rings-ax-Desktop-Wallpaper-HD.jpg",
        Expires: 3600
      };
      s3.getSignedUrl("getObject", paramsDown, function(err, data) {
        if (err) {
          console.log("Error getting Signed Url: ", err);
        } else {
          console.log("Generated Signed Url: ", data);
          return data;
        }
      });
    },
    test: function() {
      if (this.imageSelect) {
        const uploadParams = { Bucket: bucket_name, Key: "", Body: "" };
        const file = this.imageSelect;
        uploadParams.Key = file.name;
        uploadParams.Body = file;
        // uploadParams.Body = fileStream;
        // const path = require("path");
        // uploadParams.Key = path.basename(file);
        // fileStream.on("error", function(err) {
        //   console.log("File Error", err);
        // });
        s3.upload(uploadParams, function(err, data) {
          if (err) {
            console.log(err);
          } else {
            console.log(data);
          }
        });
      } else {
        console.log("file ko ton tai");
      }
    }
  }
};
</script>